Index: project/src/state.sh
===================================================================
--- project/src/state.sh	(revision 1)
+++ project/src/state.sh	(nonexistent)
@@ -1 +0,0 @@
-java -Djava.net.preferIPv4Stack=true -Djava.rmi.serv.codebase=file:/Users/zemiguel/IdeaProjects/SDIS-P1/src/main/java/service/ main/java/testapp/TestApp 127.0.0.1/obj STATE
\ No newline at end of file
Index: project/src/reclaim.sh
===================================================================
--- project/src/reclaim.sh	(revision 1)
+++ project/src/reclaim.sh	(nonexistent)
@@ -1,3 +0,0 @@
-javac -cp /Users/zemiguel/IdeaProjects/SDIS-P1/src/ main/java/testapp/TestApp.java
-
-java -Djava.net.preferIPv4Stack=true -Djava.rmi.serv.codebase=file:/Users/zemiguel/IdeaProjects/SDIS-P1/src/main/java/service/ main/java/testapp/TestApp 127.0.0.1/obj RECLAIM 0
\ No newline at end of file
Index: project/src/restore2.sh
===================================================================
--- project/src/restore2.sh	(revision 1)
+++ project/src/restore2.sh	(nonexistent)
@@ -1,3 +0,0 @@
-javac -cp /Users/zemiguel/IdeaProjects/SDIS-P1/src/ main/java/testapp/TestApp.java
-
-java -Djava.net.preferIPv4Stack=true -Djava.rmi.serv.codebase=file:/Users/zemiguel/IdeaProjects/SDIS-P1/src/main/java/service/ main/java/testapp/TestApp 127.0.0.1/obj RESTORE test2.txt
\ No newline at end of file
Index: project/src/backup.sh
===================================================================
--- project/src/backup.sh	(revision 1)
+++ project/src/backup.sh	(nonexistent)
@@ -1,3 +0,0 @@
-javac -cp /Users/zemiguel/IdeaProjects/SDIS-P1/src/ main/java/testapp/TestApp.java
-
-java -Djava.net.preferIPv4Stack=true -Djava.rmi.serv.codebase=file:/Users/zemiguel/IdeaProjects/SDIS-P1/src/main/java/service/ main/java/testapp/TestApp 127.0.0.1/obj BACKUP /Users/zemiguel/IdeaProjects/SDIS-P1/src/files/test1.pdf 1
\ No newline at end of file
Index: project/src/restore.sh
===================================================================
--- project/src/restore.sh	(revision 1)
+++ project/src/restore.sh	(nonexistent)
@@ -1,3 +0,0 @@
-javac -cp /Users/zemiguel/IdeaProjects/SDIS-P1/src/ main/java/testapp/TestApp.java
-
-java -Djava.net.preferIPv4Stack=true -Djava.rmi.serv.codebase=file:/Users/zemiguel/IdeaProjects/SDIS-P1/src/main/java/service/ main/java/testapp/TestApp 127.0.0.1/obj RESTORE test1.pdf
\ No newline at end of file
Index: project/src/reset.sh
===================================================================
--- project/src/reset.sh	(revision 1)
+++ project/src/reset.sh	(nonexistent)
@@ -1,3 +0,0 @@
-find . -type f -name '*.class' -delete
-
-rm -r peer[0-9]
\ No newline at end of file
Index: project/src/peer.sh
===================================================================
--- project/src/peer.sh	(revision 1)
+++ project/src/peer.sh	(nonexistent)
@@ -1 +0,0 @@
-java -Djava.net.preferIPv4Stack=true -Djava.rmi.server.codebase=file:/Users/zemiguel/IdeaProjects/SDIS-P1/src/main/java/service/ main/java/peer/Peer 1.0 1 224.0.0.0:8000 224.0.0.0:8001 224.0.0.0:8002
\ No newline at end of file
Index: project/src/backup2.sh
===================================================================
--- project/src/backup2.sh	(revision 1)
+++ project/src/backup2.sh	(nonexistent)
@@ -1,3 +0,0 @@
-javac -cp /Users/zemiguel/IdeaProjects/SDIS-P1/src/ main/java/testapp/TestApp.java
-
-java -Djava.net.preferIPv4Stack=true -Djava.rmi.serv.codebase=file:/Users/zemiguel/IdeaProjects/SDIS-P1/src/main/java/service/ main/java/testapp/TestApp 127.0.0.1/obj BACKUP /Users/zemiguel/IdeaProjects/SDIS-P1/src/files/test2.txt 1
\ No newline at end of file
Index: project/src/delete.sh
===================================================================
--- project/src/delete.sh	(revision 1)
+++ project/src/delete.sh	(nonexistent)
@@ -1,3 +0,0 @@
-javac -cp /Users/zemiguel/IdeaProjects/SDIS-P1/src/ main/java/testapp/TestApp.java
-
-java -Djava.net.preferIPv4Stack=true -Djava.rmi.serv.codebase=file:/Users/zemiguel/IdeaProjects/SDIS-P1/src/main/java/service/ main/java/testapp/TestApp 127.0.0.1/obj DELETE test1.pdf
\ No newline at end of file
Index: project/src/rmipeer.sh
===================================================================
--- project/src/rmipeer.sh	(revision 1)
+++ project/src/rmipeer.sh	(nonexistent)
@@ -1,5 +0,0 @@
-find . -type f -name '*.class' -delete
-
-javac -cp /Users/zemiguel/IdeaProjects/SDIS-P1/src/ main/java/peer/Peer.java
-
-java -Djava.net.preferIPv4Stack=true -Djava.rmi.server.codebase=file:/Users/zemiguel/IdeaProjects/SDIS-P1/src/main/java/service/ main/java/peer/Peer 1.0 0 192.168.0.1 224.0.0.0:8000 224.0.0.0:8001 224.0.0.0:8002
\ No newline at end of file