Index: lab5.c
===================================================================
--- lab5.c	(revision 114)
+++ lab5.c	(revision 115)
@@ -275,105 +275,8 @@
 }
 
 int(video_test_move)(xpm_map_t xpm, uint16_t xi, uint16_t yi, uint16_t xf, uint16_t yf, int16_t speed, uint8_t fr_rate) {
-    int r;
-    if ((r = get_permissions_first_mbyte()))
-        panic("%s: sys_privctl (ADD MEM) failed: %d\n", __func__, r);
 
-    if (vbe_get_mode_information(mode)) {
-        printf("%s: failed to get information for mode %x.\n", __func__, mode);
-        if (vg_exit()) printf("%s: vg_exit failed to exit to text mode.\n", __func__);
-        return 1;
-    }
-
-    map_vram(); // if function fails it aborts program
-
-    if (set_graphics_mode(mode)) {
-        printf("%s: failed to set graphic mode %x.\n", __func__, mode);
-        if (vg_exit()) printf("%s: vg_exit failed to exit to text mode.\n", __func__);
-        return 1;
-    }
-
-    uint16_t W = get_XRes()/no_rectangles;
-    uint16_t H = get_YRes()/no_rectangles;
-    uint32_t color, R, G, B;
-    for(uint8_t row = 0; row < no_rectangles; ++row){
-        for(uint8_t col = 0; col < no_rectangles; ++col){
-            if(get_bytes_pixel() == 1){
-                color = (first + (row * no_rectangles + col) * step) % (1 << get_bits_pixel());
-            }else{
-                R = (GET_RED(first) + col*step) % (1 << get_RedMaskSize());
-                G = (GET_GRE(first) + row*step) % (1 << get_GreenMaskSize());
-                B = (GET_BLU(first) + (col+row)*step) % (1 << get_BlueMaskSize());
-                color = SET_COLOR(R,G,B);
-            }
-            if (vg_draw_rectangle(col*W,row*H,W,H,color)) {
-                if (vg_exit()) {
-                    printf("%s: vg_exit failed to exit to text mode.\n", __func__);
-                    if (free_memory()) printf("%s: lm_free failed\n", __func__);
-                }
-                return 1;
-            }
-        }
-    }
-
-    /// loop stuff
-    int ipc_status;
-    message msg;
-    /// Keyboard interrupt handling
-    uint8_t kbc_irq_bit = KBC_IRQ;
-    int kbc_id = 0;
-    int kbc_irq = BIT(kbc_irq_bit);
-    if (subscribe_kbc_interrupt(kbc_irq_bit, &kbc_id)) {
-        if (vg_exit()) {
-            printf("%s: vg_exit failed to exit to text mode.\n", __func__);
-            if (free_memory()) printf("%s: lm_free failed\n", __func__);
-        }
-        return 1;
-    }
-    /// cycle
-    int good = 1;
-    while (good) {
-        /* Get a request message. */
-        if ((r = driver_receive(ANY, &msg, &ipc_status)) != 0) {
-            printf("driver_receive failed with %d", r);
-            continue;
-        }
-        if (is_ipc_notify(ipc_status)) { /* received notification */
-            switch (_ENDPOINT_P(msg.m_source)) {
-                case HARDWARE: /* hardware interrupt notification */
-                    if (msg.m_notify.interrupts & kbc_irq) { /* subscribed interrupt */
-                        kbc_ih();
-                        if (scancode[0] == ESC_BREAK_CODE) good = 0;
-                    }
-                    break;
-                default:
-                    break; /* no other notifications expected: do nothing */
-            }
-        } else { /* received standart message, not a notification */
-            /* no standart message expected: do nothing */
-        }
-    }
-
-    if (unsubscribe_interrupt(&kbc_id)) {
-        if (vg_exit()) {
-            printf("%s: vg_exit failed to exit to text mode.\n", __func__);
-            if (free_memory()) printf("%s: lm_free failed\n", __func__);
-        }
-        return 1;
-    };
-
-    if (vg_exit()) {
-        printf("%s: vg_exit failed to exit to text mode.\n", __func__);
-        if (free_memory()) printf("%s: lm_free failed\n", __func__);
-        return 1;
-    }
-
-    if (free_memory()) {
-        printf("%s: lm_free failed\n", __func__);
-        return 1;
-    }
-
-    return 0;
+    return 1;
 }
 
 int(video_test_controller)() {